import language from '../helper/language.js';
import Counter from '../helper/counter.js';
import { CLOSE_WAIT_TIMEOUT } from "../constants.js";
const startResults = (logger, calculator, finished, reportModifiers, resultHandler, resultOutputDir, resolver) => {
    if (!Counter.isEmpty('active') || !Counter.isEmpty('analyzing')) {
        return;
    }
    calculator.terminate();
    logger.info(language('starting_result'));
    logger.debug(language('data'), finished);
    let hasErrors = false;
    for (const reportModifier of reportModifiers) {
        for (const set of Object.keys(finished)) {
            finished[set] = reportModifier.adjust(finished[set]);
            hasErrors = hasErrors || finished[set].errors > 0;
        }
    }
    resultHandler(finished, resultOutputDir);
    logger.info(language('done'));
    setTimeout(() => resolver.resolve(hasErrors), CLOSE_WAIT_TIMEOUT);
};
const onCalculate = (data, finished, now, resultStorage, logger, progress, calculator, reportModifiers, reporter, resultOutputDir, resolver) => {
    finished[data.id] = data;
    resultStorage.store(data, now);
    logger.debug(language('finished_analyzing', data.id));
    Counter.decrement('analyzing');
    progress.increment();
    startResults(logger, calculator, finished, reportModifiers, reporter, resultOutputDir, resolver);
};
export default onCalculate;
